/**CHeaderFile*****************************************************************

  FileName    [trInt.h]

  PackageName [Tr]

  Synopsis    [Internal header file]

  Description []

  SeeAlso     []  

  Author      [Gianpiero Cabodi and Stefano Quer]

  Copyright   [This file was created at the Politecnico di Torino,
    Torino, Italy. 
    The  Politecnico di Torino makes no warranty about the suitability of 
    this software for any purpose.  
    It is presented on an AS IS basis.]
  
  Revision    []

******************************************************************************/

#ifndef _TRINT
#define _TRINT

/*---------------------------------------------------------------------------*/
/* Nested includes                                                           */
/*---------------------------------------------------------------------------*/

#include "tr.h"
#include "pdtutil.h"
#include "part.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

/* error number */
#define TRSORT_OUT_OF_MEM -1
#define TRSORT_INVALID_SORTING_METHOD -2

/*---------------------------------------------------------------------------*/
/* Structure declarations                                                     */
/*---------------------------------------------------------------------------*/

/**Struct*********************************************************************

 Synopsis    [Transition Relation Manager]

 Description [The Transition Relation manager structure]

******************************************************************************/

struct Tr_Mgr_s {
  char *trName;

  Ddi_DdMgr      *DdiMgr;       /* DD manager */
  Ddi_Dd_t       *tr;           /* transition relation function */
  Ddi_VarArray_t *i;            /* primary inputs */
  Ddi_VarArray_t *ps;           /* present state variables */
  Ddi_VarArray_t *ns;           /* next state variables */

  long trTime;

  struct {
    Pdtutil_VerbLevel_e verbosity;
    Tr_Sort_e sortMethod;
    int ClustThreshold;
    double SortW[5];
    int maxIter;
    int SquaringMethod;
  } settings;
};	

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/

/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN Ddi_Dd_t * TrBuildTransClosure(Tr_Mgr_t *TrMgr, Ddi_Dd_t *TR, Ddi_VarArray_t *s, Ddi_VarArray_t *y, Ddi_VarArray_t *z);

/**AutomaticEnd***************************************************************/


#endif /* _TRINT */



